--
-- @filename module.adb
-- @author Julien Burdy & Vincent Decorges
-- @date 17.6.02
-- @brief AdaDoc root module (class)
--
-- History  :
-- Date     Modification               Author
--
with Ada.Strings.Fixed;
package body Module is


   ----------------
   -- Initialize --
   ----------------
   -- Initialize the module with options.
   procedure Initialize (Self : in out Object; Options : String) is
   begin
      Self.Options := new String'(Options); -- Options string
   end Initialize;

   ------------------
   -- Option_Exist --
   ------------------
   -- Return true if Option has be entered by the user.
   function Option_Exist (Self : Object; Option : String) return Boolean is
   begin
      return Ada.Strings.Fixed.Count(Self.Options.All, Option) > 0;
   end Option_Exist;


   --------------------------------------------------------------------------------------
   -- Others subprograms are null.

   --------------
   -- A_Choice --
   --------------
   procedure A_Choice (Self : Object; Atts : Dict_Type; Its_Value : String) is
   begin
      null;
   end A_Choice;


   --------------
   -- A_Clause --
   --------------
   procedure A_Clause (Self : Object; Atts : Dict_Type; Its_Value : String) is
   begin
      null;
   end A_Clause;


   ----------------
   -- A_Function --
   ----------------
   procedure A_Function (Self : Object; Atts : Dict_Type; Its_Name,
                         Its_Return_Type : String; In_Prot_Obj : Boolean) is
   begin
      null;
   end A_Function;


   ------------------------
   -- A_Generic_Instance --
   ------------------------
   procedure A_Generic_Instance (Self : Object; Atts : Dict_Type; Its_Name : String) is
   begin
      null;
   end A_Generic_Instance;


   ------------------------------
   -- A_Package_Subprogram_Gen --
   ------------------------------
   procedure A_Package_Subprogram_Gen (Self : Object; Atts : Dict_Type;
                                       Its_Name : String) is
   begin
      null;
   end A_Package_Subprogram_Gen;


   -----------------
   -- A_Parameter --
   -----------------
   procedure A_Parameter (Self : Object; Atts : Dict_Type; Its_Name, Its_Type,
                                                           Its_Mode : String) is
   begin
      null;
   end A_Parameter;


   -----------------
   -- A_Procedure --
   -----------------
   procedure A_Procedure (Self : Object; Atts : Dict_Type; Its_Name : String;
                          In_Prot_Obj : Boolean) is
   begin
      null;
   end A_Procedure;


   --
   -- Purpose : Receive notification of each pragma.
   --
   -- Self     : Object itself.
   -- Atts     : The attributs dictionary of the XML current element.
   -- Its_Name : the pragma name
   --
   procedure A_Pragma (Self : Object;
                       Atts : Dict_Type;
                       Its_Name : String) is
   begin
      null;
   end A_Pragma;

   ------------------------
   -- A_Protected_Object --
   ------------------------
   procedure A_Protected_Object (Self : Object; Atts : Dict_Type; Its_Name : String) is
   begin
      null;
   end A_Protected_Object;


   --------------
   -- A_Record --
   --------------
   procedure A_Record (Self : Object; Atts : Dict_Type; Its_Name : String) is
   begin
      null;
   end A_Record;

   --------------
   -- A_Rename --
   --------------
   procedure A_Rename (Self : Object; Atts : Dict_Type; Its_Name : String) is
   begin
      null;
   end A_Rename;


   ------------
   -- A_Task --
   ------------
   procedure A_Task (Self : Object; Atts : Dict_Type; Its_Name : String) is
   begin
      null;
   end A_Task;


   -----------------------
   -- A_Type_Definition --
   -----------------------
   procedure A_Type_Definition (Self : Object; Atts : Dict_Type; Its_Name,
                                                                 Its_Def : String) is
   begin
      null;
   end A_Type_Definition;


   --------------------
   -- A_Variant_Part --
   --------------------
   procedure A_Variant_Part (Self : Object; Atts : Dict_Type; Its_Discriminant : String)
   is
   begin
      null;
   end A_Variant_Part;


   --------------
   -- An_Entry --
   --------------
   procedure An_Entry (Self : Object; Atts : Dict_Type; Its_Name : String) is
   begin
      null;
   end An_Entry;


   ------------------
   -- An_Exception --
   ------------------
   procedure An_Exception (Self : Object; Atts : Dict_Type; Its_Name : String) is
   begin
      null;
   end An_Exception;


   ---------------
   -- An_Object --
   ---------------
   procedure An_Object (Self : Object; Atts : Dict_Type; Its_Name, Its_Type : String;
                        Is_Component : Boolean) is
   begin
      null;
   end An_Object;


   -----------------
   -- End_Element --
   -----------------
   procedure End_Element (Self : Object; Element : Element_Type) is
   begin
      null;
   end End_Element;


   -----------------
   -- Start_Group --
   -----------------
   procedure Start_Group (Self : Object; Group : Element_Type) is
   begin
      null;
   end Start_Group;

end Module;
